<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_preloaded_regular_screen.php';

class MoidomVodRootScreen extends AbstractPreloadedRegularScreen
{
    const ID = 'vod_root';

    private $session;

    public function __construct($session, $folder_views)
    {
        parent::__construct(self::ID, $folder_views);

        $this->session = $session;
    }

    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
        return array
        (
            GUI_EVENT_KEY_ENTER => ActionFactory::open_folder(),
        );
    }

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies)
    {
		$lang = $this->session->get_lang();
		
        $defs = array(
            array(
                MoidomVodListScreen::get_media_url_str('last'),
                $this->session->get_language()->$lang->last, "plugin_file://icons/groups/vod/".$lang."/last.png"),
            array(
                MoidomVodListScreen::get_media_url_str('best'),
                $this->session->get_language()->$lang->best, "plugin_file://icons/groups/vod/".$lang."/best.png"),
            array(
                VodFavoritesScreen::get_media_url_str(),
                $this->session->get_language()->$lang->my_movies, "plugin_file://icons/groups/vod/".$lang."/mymovies.png"),
            array(
                VodGenresScreen::get_media_url_str(),
                $this->session->get_language()->$lang->genres, "plugin_file://icons/groups/vod/".$lang."/genres.png"),
            array(
                VodSearchScreen::get_media_url_str(),
                $this->session->get_language()->$lang->search, "plugin_file://icons/groups/vod/".$lang."/search.png")
        );

        $items = array();

        foreach ($defs as $def)
        {
			//hd_print($def[2]);
			//hd_print($this->session->get_icon($def[2]));
            $items[] = array
            (
                PluginRegularFolderItem::media_url => $def[0],
                PluginRegularFolderItem::caption => $def[1],
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path => $def[2]
                )
            );
        }
//$this->session->get_icon($def[2])
        return $items;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
